package de.uni_stuttgart.fmi.szs.jmoped.eclipse;

import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.eclipse.debug.ui.AbstractLaunchConfigurationTab;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;

import de.uni_stuttgart.fmi.szs.jmoped.eclipse.gui.LaunchConfigurationControl;
import de.uni_stuttgart.fmi.szs.jmoped.eclipse.gui.LaunchConfigurationControl.SettingsChangedListener;

public class MCLaunchConfigurationMainTab extends AbstractLaunchConfigurationTab
{
	private LaunchConfigurationControl configControl;

	public void createControl(Composite parent) 
	{
		Composite top = new Composite(parent, SWT.NONE);
		top.setLayout(new FillLayout());
		setControl(top);
		
		configControl = new LaunchConfigurationControl(top, SWT.NONE);
		configControl.addSettingsChangedListener(new SettingsChangedListener() {
			public void settingChanged() {
				updateLaunchConfigurationDialog();
			}
		});
	}

	public void setDefaults(ILaunchConfigurationWorkingCopy configuration) 
	{
		
	}

	public void initializeFrom(ILaunchConfiguration configuration) 
	{
		configControl.setFrom(configuration);
	}

	public void performApply(ILaunchConfigurationWorkingCopy configuration) 
	{
		configControl.applySettings(configuration);
	}

	public String getName() 
	{
		return "Moped Coverage";
	}

}
