package de.uni_stuttgart.fmi.szs.jmoped.eclipse;

import org.eclipse.core.resources.IResource;

import de.uni_stuttgart.fmi.szs.jmoped.PDS;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.CoverageMethod;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.CoverageResult;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.Transition;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.CoverageMethod.State;
import de.uni_stuttgart.fmi.szs.jmoped.eclipse.marker.MarkerManager;

public class PreStarCoverageListener extends TestCoverageListener 
{
	private String launchConfigurationMemento;

	public PreStarCoverageListener(IResource resource,
								   String launchConfigurationMemento)
	{
		super(resource, launchConfigurationMemento);
		this.launchConfigurationMemento = launchConfigurationMemento;
	}
	
	@Override
	public void coverageStarted(PDS pds) 
	{
		MarkerManager.getInstance().removeCoverageResult
			(launchConfigurationMemento);
		// Remy: Delete old markers
		startRunner(true);
	}

	
	@Override
	public void coveredMethodOffset(CoverageMethod method, int lineOffset, 
									int  pcOffset, State state, 
									Transition transition) 
	{
		if (state != State.ASSERTION_FAILED) {
			super.coveredMethodOffset(method, lineOffset, pcOffset, state,
									  transition);
		}
	}
	

	@Override
	public void coverageEnded(CoverageResult result) 
	{
		// TODO connect prestar with post star and remove results in manager
		MarkerManager.getInstance().addCoverageResult
			(launchConfigurationMemento, result);
	}

	@Override
	public void coverageFailed(String message, Throwable t) 
	{
		 
	}

}
