package de.uni_stuttgart.fmi.szs.jmoped.eclipse;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.source.IVerticalRulerInfo;
import org.eclipse.ui.texteditor.IDocumentProvider;
import org.eclipse.ui.texteditor.ITextEditor;

public class SetWatchPointAction extends Action
{
	private ITextEditor editor;
	private IDocument fDocument = null;
	private IVerticalRulerInfo fRulerInfo;

	public SetWatchPointAction(ITextEditor editor, IVerticalRulerInfo rulerInfo) 
	{
		super("Set Watch Point");
		this.editor = editor;
		fRulerInfo = rulerInfo;
	}
	/*
	 *  (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() 
	{
		IDocument document= getDocument();
		if (document == null) {
			return;
		}
	}
	
	/**
	 * Disposes this action. Clients must call this method when
	 * this action is no longer needed.
	 */
	public void dispose() 
	{
		fDocument = null;
		editor = null;
		fRulerInfo = null;
	}

	/**
	 * Returns the document on which this action operates.
	 * 
	 * @return the document or <code>null</code> if none
	 */
	private IDocument getDocument() 
	{
		if (fDocument != null) {
			return fDocument;
		}
		
		IDocumentProvider provider = editor.getDocumentProvider();
		if (provider != null) {
			return provider.getDocument(editor.getEditorInput());
		}
		return null;
	}

}
