package de.uni_stuttgart.fmi.szs.jmoped.eclipse.gui;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import de.uni_stuttgart.fmi.szs.jmoped.coverage.CoverageMethod;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.CoverageMethod.State;

public class CoverageMethodStateFilter extends ViewerFilter 
{

	private State state;
	
	public CoverageMethodStateFilter(State state)
	{
		this.state = state;
	}
	
	@Override
	public boolean select(Viewer viewer, Object parentElement, Object element) 
	{
		if (element instanceof TransitionState) {
			return ((TransitionState)element).getState() == state;
		}
		else if (element instanceof InstructionState) {
			return ((InstructionState)element).getState() == state;
		}
		if (state == State.COVERED || state == State.PARTIALLY_COVERED) {
			if (element instanceof CoverageMethod) {
				CoverageMethod method = (CoverageMethod)element;
				if (method.isFullyCovered()) {
					return state == State.COVERED;
				}
				else {
					return state == State.PARTIALLY_COVERED;
				}
			}
		}
		return false;
	}
}
