package de.uni_stuttgart.fmi.szs.jmoped.eclipse.gui;

import org.eclipse.core.runtime.Path;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.search.TypeNameRequestor;
import org.eclipse.jdt.internal.corext.util.TypeInfo;
import org.eclipse.jdt.internal.corext.util.TypeInfoFactory;
import org.eclipse.jdt.internal.ui.javaeditor.EditorUtility;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IDocument;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.PartInitException;

import de.uni_stuttgart.fmi.szs.jmoped.eclipse.SearchUtils;

public class OpenMethodInEditorAction extends Action 
{
	private String className;
	private int line;
	
	/**
	 * 
	 * @param className
	 * @param line 1-based line number
	 */
	public OpenMethodInEditorAction(String className, int line)
	{
		this.className = className;
		this.line= line;
		setText("Jump to line " + line);
	}
	
	@Override
	public void run() 
	{		
		try {
			SearchUtils.searchMethod(className, new ClassNameRequestor());
		}
		catch (JavaModelException e) {
		}
	}
	
	private class ClassNameRequestor extends TypeNameRequestor
	{
		@Override
		public void acceptType(int modifiers, char[] packageName, 
				char[] simpleTypeName, char[][] enclosingTypeNames, String path) 
		{
			TypeInfoFactory factory = new TypeInfoFactory();
			TypeInfo typeInfo = factory.create(packageName, simpleTypeName, 
					enclosingTypeNames, modifiers, path);
			try {
				IType type = typeInfo.resolveType(null);
				IEditorPart part = EditorUtility.openInEditor(type, true);
				IDocument document = SearchUtils.getDocument(new Path(path));
				if (document != null) {
					int offset = document.getLineOffset(line - 1);
					EditorUtility.revealInEditor(part, offset, 0);
				}
				else {
					EditorUtility.revealInEditor(part, 0, 0);
				}
			}
			catch (JavaModelException e) {
			} 
			catch (PartInitException e) {
			}
			catch (BadLocationException e) {
			}
		}
	}
	
}
