package de.uni_stuttgart.fmi.szs.jmoped.eclipse.gui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IMemento;

import de.uni_stuttgart.fmi.szs.jmoped.coverage.CoverageMethod;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.CoverageResult;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.TraceNode;

public class TabControl extends Composite
{
	
	private static final int COVERAGE_TABLE_INDEX = 0;
	
	private static final int CALL_TRACE_INDEX = 1;
	
	private CTabFolder tabFolder;
	
	private MethodCallTraceTreeControl callTrace;
	
	private CoverageMethodTreeControl coverageTree;
	
	private CoverageMethodTableControl coverageTable;

	public TabControl(Composite parent, int style)
	{
		super(parent, style);
	
		setLayout(new FillLayout(SWT.VERTICAL));
		
		tabFolder = new CTabFolder(this, SWT.TOP);
		
		CTabItem item = new CTabItem(tabFolder, SWT.NONE);
		coverageTable = new CoverageMethodTableControl(tabFolder, SWT.NONE);
		item.setControl(coverageTable);
		item.setText("Covered Methods");
		
		item = new CTabItem(tabFolder, SWT.NONE);
		callTrace = new MethodCallTraceTreeControl(tabFolder, SWT.NONE);
		item.setControl(callTrace);
		item.setText("Call Trace");
		
	}
	
	public void setTraceTree(TraceNode[] roots)
	{
		callTrace.setTraceTree(roots);
		tabFolder.setSelection(CALL_TRACE_INDEX);
	}
	
	public void clearTraceTree()
	{
		callTrace.setTraceTree(null);
	}
	
	public void setResult(CoverageResult result)
	{
		coverageTable.setResult(result);
		tabFolder.setSelection(COVERAGE_TABLE_INDEX);
	}

	public void saveState(IMemento memento) 
	{
		coverageTable.saveState(memento);
	}

	public void init(IMemento memento) 
	{
		coverageTable.init(memento);
	}
	
}
