package de.uni_stuttgart.fmi.szs.jmoped.eclipse.marker;

import java.util.HashMap;
import java.util.Map;

import de.uni_stuttgart.fmi.szs.jmoped.coverage.CoverageResult;

public class MarkerManager 
{

	private static MarkerManager instance = new MarkerManager();
	
	private Map<String, Map> markersByLaunchConfiguration = new HashMap<String, Map>();
	
	private Map<String, CoverageResult> resultsByMemento = 
		new HashMap<String, CoverageResult>();
	
	private MarkerManager()
	{
		
	}
	
	public static MarkerManager getInstance()
	{
		return instance;
	}
	
	public void addMarkerMap(String launchConfigurationMemento, Map markerMap)
	{
		markersByLaunchConfiguration.put(launchConfigurationMemento, markerMap);
	}
	
	public Map getMarkerMap(String launchConfigurationMemento)
	{
		return (Map)markersByLaunchConfiguration.get(launchConfigurationMemento);
	}
	
	public void removeMarkerMap(String launchConfigurationMemento)
	{
		markersByLaunchConfiguration.remove(launchConfigurationMemento);
	}
	
	public void addCoverageResult(String launchConfigurationMemento, 
			CoverageResult result)
	{
		resultsByMemento.put(launchConfigurationMemento, result);
	}
	
	public CoverageResult getCoverageResult(String launchConfigurationMemento)
	{
		return (CoverageResult)resultsByMemento.get(launchConfigurationMemento);
	}
	
	public void removeCoverageResult(String launchConfigurationMemento)
	{
		resultsByMemento.remove(launchConfigurationMemento);
	}
	
	public void clearCoverageResults()
	{
		resultsByMemento.clear();
	}
	
}
