package greedy;

import java.util.*;
class Node implements Comparator {
    char    character;
    int     occurrences;
    char    bit;
    Node    parent;

    public Node(){};
    public Node(char c, int n) {
       character = c;
       occurrences = n;
    }
    public int compare(Object o1, Object o2) {
        Node n1 = (Node) o1;
        Node n2 = (Node) o2;
        return (n1.occurrences - n2.occurrences);
    }
}

class Huffman { 
  public static Node merge(Node n1, Node n2) {
    Node n = new Node();
    n.occurrences = n1.occurrences + n2.occurrences;
    n1.bit = '0'; n1.parent = n;
    n2.bit = '1'; n2.parent = n;
    return n;
  }
  public static void makeTree(LinkedList l) {
    TreeSet t = new TreeSet(new Node());     
    t.addAll(l);
    while (t.size() >= 2) {
      Node n1 = (Node) t.first();
      t.remove(n1);
      Node n2 = (Node) t.first();
      t.remove(n2);
      Node n = merge(n1,n2);
      t.add(n);
    }
  }
}

      
  