package de.uni_stuttgart.fmi.szs.jmoped.coverage;

import de.uni_stuttgart.fmi.szs.jmoped.PDS;
import de.uni_stuttgart.fmi.szs.moped.IntPds;
import de.uni_stuttgart.fmi.szs.moped.MopedResult;
import de.uni_stuttgart.fmi.szs.moped.WFa;

/**
 * Peer class that manages handles to native data structures.
 * <p>
 * Do not keep references to this class around unless you need them. Also
 * consider using {@link java.lang.ref.WeakReference weak references} for
 * holding references to it.
 */
public class CoverageResult extends MopedResult {

	//private final IntPds pds;
	
	//private final IntResult result;
	
	private PDS jPds;
	
	private CoverageMethod[] methods = new CoverageMethod[0];
	
//	CoverageResult(IntPds pds, IntResult result)
//	{
//		this.pds = pds;
//		this.result = result;
//	}
	
	CoverageResult(IntPds pds, WFa fa) {
		
		super(pds, fa);
	}
	
	void setMethods(CoverageMethod[] methods) {
		
		this.methods = methods; 
	}
	
	public CoverageMethod[] getMethods() {
		
		return methods;
	}
	
//	IntPds getIntPds()
//	{
//		return pds;
//	}
	
//	IntResult getResult()
//	{
//		return result;
//	}
	
	void setPDS(PDS pds) {
		
		this.jPds = pds;
	}
	
	public PDS getPDS(){
		
		return jPds; 
	}
	
//	@Override
//	public String toString() 
//	{
//		return pds + ", " + result;
//	}
	
	public boolean isPostTrace() {
		
		return getWFa().getDir() > 0;
	}
}
