package de.uni_stuttgart.fmi.szs.jmoped.coverage;


/**
 * Default implementation of the TraceNode interface. 
 */
public class DefaultTraceNode implements TraceNode 
{

	private TraceNode parent;
	
	private TraceNode[] children;
	
	private MethodCall call;
	
	public DefaultTraceNode(MethodCall call, TraceNode parent, TraceNode[] children)
	{
		this.call = call;
		this.parent = parent;
		this.children = children;
	}
	
	public void setChildren(TraceNode[] children)
	{
		this.children = children;
	}
	
	public TraceNode getParent() 
	{
		return parent;
	}

	public boolean hasChildren() 
	{
		return children.length > 0;
	}

	public TraceNode[] getChildren() 
	{
		return children;
	}

	public MethodCall getMethodCall() 
	{
		return call;
	}

	@Override
	public String toString() 
	{
		return call.toString();
	}
}
