package de.uni_stuttgart.fmi.szs.jmoped.coverage;

import de.uni_stuttgart.fmi.szs.jmoped.PDSMethod;

/**
 * A Java method call, part of a moped call trace.
 */
public interface MethodCall 
{
	/**
	 * Returns the arguments of the method call.
	 * 
	 * @return empty array for methods without parameters
	 */
	MethodArgument[] getArguments();
	/**
	 * Returns the instance on which the method was called if the method is not
	 * static.
	 * @return null if method is static
	 */
	MethodArgument getInstance();
	/**
	 * The config at which this method call takes place.
	 */
	IntConfig getConfig();
	/**
	 * The method that is called.
	 */
	PDSMethod getMethod();
}
