package de.uni_stuttgart.fmi.szs.jmoped.coverage;

/**
 * Defines the requirements for a class that denotes a formal method paramter. 
 */
public interface Parameter 
{
	/**
	 * Returns true if the parameter denotes a type that is passed by value.
	 */
	boolean isValue();
	/**
	 * Returns true if the parameter denotes an array of primitive types. 
	 */
	boolean isValueArray();
	/**
	 * Returns true if the parameter denotes a non primitive type.
	 */
	boolean isReference();
	/**
	 * Returns true if the parameter denotes an array of non primitive types.
	 * @return
	 */
	boolean isReferenceArray();
	/**
	 * Return the name of the type.
	 * <p>
	 * For primitive types, these are "I", "Z", "J", etc. 
	 * For object types it is the name of the class, where 
	 * packages are separated by slashes.
	 * @return
	 */
	String getType();
}
