package de.uni_stuttgart.fmi.szs.jmoped.coverage;

import de.uni_stuttgart.fmi.szs.moped.IntPds;
import de.uni_stuttgart.fmi.szs.moped.WFa;

/**
 * This class generates counter example traces for a transition.
 */
public class TraceGenerator
{

	static {
		System.loadLibrary("mopedcoverage");
	}

	/**
	 * Generates a counter example trace for how the transition was reached.
	 * 
	 * @param result contains the information needed for generating the trace
	 * @param transition
	 * @return
	 */
	public static IntConfig getTraceConfig(CoverageResult result, Transition transition)
	{
		synchronized (Coverage.class) {
			return getTraceConfig(result.getIntPds(), result.getWFa(),
					transition.getFrom(), transition.getName(), transition.getTo());
			}
		}
		
	private native static IntConfig getTraceConfig(IntPds ipds, WFa fa, 
			long from, long name, long to);
		
}
