package de.uni_stuttgart.fmi.szs.jmoped.coverage;

/**
 * A node in the method call trace tree generated by 
 * {@link de.uni_stuttgart.fmi.szs.jmoped.coverage.JavaMethodArgumentsResolver#resolveMethodCallTraceTree(IntConfig, PDS)}.
 * <p>
 * The node represents a method call. Its children are the calls to methods which are
 * invoked in this method.
 */
public interface TraceNode 
{
	/**
	 * Returns the node of the caller method or null if there is none. 
	 */
	TraceNode getParent();
	/**
	 * Returns whether other methods are called in this method.
	 */
	boolean hasChildren();
	/**
	 *Returns the array of method calls invoked from this method in this counter example.
	 */
	TraceNode[] getChildren();
	/**
	 * Returns the method call.
	 */
	MethodCall getMethodCall();
}
