package de.uni_stuttgart.fmi.szs.jmoped.coverage;

public class Transition 
{

	private final int from;
	
	private final int name;
	
	private final int to;
	
	private int hash = -1;

	public Transition(int from, int name, int to) 
	{
		this.from = from;
		this.name = name;
		this.to = to;
//		System.out.println(from + " - " + name + " - " + to);
	}

	public int getFrom()
	{
		return from;
	}

	public int getName() 
	{
		return name;
	}

	public int getTo() 
	{
		return to;
	}
	
	@Override
	public boolean equals(Object obj) 
	{
		if (obj instanceof Transition) {
			Transition other = (Transition)obj;
			return from == other.from && name == other.name && to == other.to; 
		}
		return false;
	}
		
	@Override
	public int hashCode() 
	{
		if (hash == -1) {
			hash = ((from + name) * (from + name + 1)) / 2 + from;
			hash = ((hash + to) * (hash+ to + 1)) / 2 + to;
		}
		return hash;
	}
	
	@Override
	public String toString() 
	{
		return from + " - " + name + " - " + to;
	}
}
