package de.uni_stuttgart.fmi.szs.jmoped;

import java.awt.BorderLayout;

import org.gjt.jclasslib.structures.CPInfo;
import org.gjt.jclasslib.structures.ClassFile;
import org.gjt.jclasslib.structures.MethodInfo;
import org.gjt.jclasslib.structures.attributes.CodeAttribute;
import org.gjt.jclasslib.structures.attributes.LineNumberTableAttribute;

public class ClassFileTest extends PDSTestCase 
{
	
	private ClassFile classFile;
	
	@Override
	protected void setUp() throws Exception 
	{
		classFile = getPDS(LineTestClass.class).getInfo().getInvokeAnalyzer()
				.getRootClassFile();
	}
	
	public void testGetMethod() throws Exception
	{
		MethodInfo emptyMethod = classFile.getMethod("emptyMethod",  "()V");
		assertNotNull(emptyMethod);
	}

	public void testLines() throws Exception
	{
		MethodInfo[] methods = classFile.getMethods();
		MethodInfo emptyMethod = methods[1];
		CodeAttribute code = 
			(CodeAttribute) emptyMethod.findAttribute(CodeAttribute.class);
		assertNotNull(code.findAttribute(LineNumberTableAttribute.class));
	}
	
	public void testOneLine() throws Exception
	{
		MethodInfo oneLineMethod = classFile.getMethod("oneLineMethod", "()V");
		CodeAttribute code = 
			(CodeAttribute) oneLineMethod.findAttribute(CodeAttribute.class);
		LineNumberTableAttribute lines = (LineNumberTableAttribute)code.findAttribute(LineNumberTableAttribute.class);
		assertNotNull(lines);
	}
	
	public static class LineTestClass
	{
		
		public void emptyMethod()
		{
		}
		
		public void oneLineMethod()
		{
			int i = 2;
		}
		
		public int questionMark(int k)
		{
			return k > 1 ? k : 1;
		}
		
		public int multipleLines(int k)
		{
			if (k > 1) {
				return 1;
			}
			if (k == 1) {
				return 1;
			}
			int i = k * k;
			return i;
		}
		
	}
	
	public void testRefs() throws Exception
	{
		ClassFile cf = BytecodeUtils.findClassFile(RefTestClass.class.getName());
		CPInfo[] pool = cf.getConstantPool();
		for (CPInfo info : pool) {
			if (info != null) {
//				System.out.println(info.getTagVerbose() + ": " + info.getVerbose());
			}
		}
	}
	
	public static class RefTestClass
	{
		public void me()
		{
			Integer i = new Integer(2);
			float f = Float.parseFloat("1.0");
			String i1 = BorderLayout.AFTER_LAST_LINE;
		}
	}
	
}
