package de.uni_stuttgart.fmi.szs.jmoped.coverage;

import de.uni_stuttgart.fmi.szs.jmoped.PDS;
import de.uni_stuttgart.fmi.szs.jmoped.PDSTestCase;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.PreStarReachabilityTesterTest.CoverageCountListener;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.TraceMinimizerTest.TwoPathsClass;

public class BranchCoverageTesterTest extends PDSTestCase 
{

	public void testGetBranchLabels() throws Exception
	{
		PDS pds = getPDS(BranchClass.class);
		assertEquals(5, BranchCoverageTester.getBranchLabels(pds).length);
		
		pds = getPDS(BranchAssertionsClass.class);
		// 4 labels for each assertion + 2 for the static inializer
		assertEquals(12, BranchCoverageTester.getBranchLabels(pds).length);
		
		pds = new PDS(TwoPathsClass.class, "test", "(I)V");
		assertEquals(3, BranchCoverageTester.getBranchLabels(pds).length);
	}
	
	public void testTest() throws Exception
	{
		BranchCoverageTester tester = new BranchCoverageTester(BranchClass.class);
		CoverageCountListener listener = new CoverageCountListener();
		tester.addCoverageListener(listener);
		tester.test();
		assertEquals(8, listener.count);
	}
	
	public void testTest2() throws Exception {
		
		BranchCoverageTester tester = new BranchCoverageTester(
				BranchAssertionsClass.class);
		CoverageCountListener listener = new CoverageCountListener();
		tester.addCoverageListener(listener);
		tester.test();
		assertEquals(15, listener.count);
	}
	
	public static class BranchClass
	{
		public static void main(String[] args) 
		{
			int i = 1;
			if (i > 0) {
				args[0] = "";
			}
			else if (i == 0 || i < 0) {
				args[0] = "";
			}
		}
	}
	
	public static class BranchAssertionsClass
	{
		public static void main(String[] args) 
		{
			int i = Integer.parseInt("");
			if (i > 0) {
				assert(i > 0);
			}
			else if (i == 0 || i  == 3) {
				assert(i > 0);
			}
		}
	}
}
