package de.uni_stuttgart.fmi.szs.jmoped.coverage;

import de.uni_stuttgart.fmi.szs.jmoped.PDSTestCase;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.TraceGeneratorTest.InputValueClassCoverageListener;

public class IntConfigTest extends PDSTestCase 
{

	private IntConfig getStartConfig(Class clazz) throws Exception
	{
		CoverageTester tester = new CoverageTester(clazz);
		InputValueClassCoverageListener listener = new InputValueClassCoverageListener();
		tester.addCoverageListener(listener);
		
		CoverageMethod[] methods = tester.test();
		CoverageResult result = listener.result;
		assertNotNull(result);
		assertNotNull(listener.transitions[0]);
		
		IntConfig startConfig = TraceGenerator.getTraceConfig(result, listener.transitions[0]);
		assertNotNull(startConfig);
		return startConfig;
	}
	
	public void testGetStackSymbol() throws Exception
	{
		CoverageTester tester = new CoverageTester(IntConfigRetrievalClass.class);
		InputValueClassCoverageListener listener = new InputValueClassCoverageListener();
		tester.addCoverageListener(listener);
		
		CoverageMethod[] methods = tester.test();
		CoverageResult result = listener.result;
		assertNotNull(result);
		assertNotNull(listener.transitions[0]);
		
		IntConfig startConfig = TraceGenerator.getTraceConfig(result, listener.transitions[0]);
		assertNotNull(startConfig);
		
		for (CoverageMethod method : methods) {
			IntConfig config = startConfig.getConfigAt(method.getMethod().getFormattedName());
			assertNotNull(config);
			assertEquals(method.getMethod().getFormattedName(), config.getStackSymbol());
		}
	}
	
	public static class IntConfigRetrievalClass
	{
		
		
		public static void main(String[] args)
		{
			test(args.length);
		}
		
		public static void test(int length)
		{
			new IntConfigRetrievalClass().method();
		}
		
		public void method()
		{
			assert(false);
		}
		
	}
	
	public void testEquals() throws Exception
	{
		IntConfig  config = getStartConfig(IntConfigRetrievalClass.class);
		IntConfig other = getStartConfig(IntConfigRetrievalClass.class);
		assertEquals(config, other);
		
		while (config != null) {
			assertEquals(config, other);
			config = config.getNextConfig();
			other = other.getNextConfig();
		}
	}
	
}
