package de.uni_stuttgart.fmi.szs.jmoped.coverage;

import de.uni_stuttgart.fmi.szs.jmoped.PDSTestCase;
import de.uni_stuttgart.fmi.szs.jmoped.coverage.TraceGeneratorTest.InputValueClassCoverageListener;

public class JavaAssertionExpressionResolverTest extends PDSTestCase
{

	public void testGetFailedAssertionComparison() throws Exception 
	{
		String[] expressions = new String[] {
				"0 != 0",
				"0 != 5 && 0 != 5 && 0 < 0",
				"5 == 5 && 5 != 5",
				"4 != 4 || 4 != 4",
				"5 != 5 || 5 == 5 && 5 < 0",
				"5 == 5 && 5 != 5 || 5 < 0",
				"3 != 3 || 3 != 3",
				"4 != 4",
				"3 < 3",
				"0 != 0",
				"false",
				"5 != 5",
				"5 != 5",
		};
		
		for (int i = 0; i < expressions.length; i++) {
			//System.out.println("i: " + i);
			CoverageTester tester = getTester(FailedAssertionsClass.class, "test" + i, "(I)V");
			InputValueClassCoverageListener listener = new InputValueClassCoverageListener();
			tester.addCoverageListener(listener);
			tester.test();
			assertEquals(expressions[i], 
					JavaAssertionExpressionResolver.getFailedAssertionExpression(
							listener.result, listener.transitions[0]));
		}
	}

	public static class FailedAssertionsClass
	{
		public static void test0(int i)
		{
			assert(i != 0);
		}
		
		public static void test1(int i)
		{
			assert(i != 5 && i  != 5 && i < 0 );
		}
		
		public static void test2(int i)
		{
			assert(i == i && i != 5);
		}
		
		public static void test3(int i)
		{
			assert(i != i || i != 4);
		}
		
		public static void test4(int i)
		{
			assert(i != 5 || i  == 5 && i < 0 );
		}

		public static void test5(int i)
		{
			assert(i == i && i  != 5 || i < 0 );
		}
		
		public static void test6(int i)
		{
			assert(i != i && i  != 5 || i != 3 );
		}
		
		public static void test7(int i)
		{
			if (i > 0) { assert(i != 0); assert(i != 4); }
		}
		
		public static void test8(int i)
		{
			assert(i < 3);
		}
		
		public static void test9(int i)
		{
			assert(fails());
		}
		
		public static void test10(int i)
		{
			assert(false);
		}
		
		public static void test11(int i)
		{
			assert(i != 5 && i == i);
		}
		
		// mixed case which fails in first comparison
		public static void test12(int i)
		{
			assert(i != 5 && (i == i || i == i));
		}
		
		public static boolean fails()
		{
			return false;
		}
	}
	
	
	
}
