package de.uni_stuttgart.fmi.szs.jmoped.data;

/**
 * Changes to make it work with moped: 
 * 
 * 1) The coins array had to be reduced
 * 2) amount is set to non-deterministic 
 *    value to test all possible input values 
 *    in the given range. 
 * 3) Asked Remy about multidemensional array
 *    support for Dynamic.
 * 4) Put return statements after ifs in extra lines so we can see
 *    if they are covered
 * 
 * Parameters:
 * 
 * 4 bits, heapsize 15
 * 
 * Results
 * 
 * Greedy works fine: the case, that there's a 
 * rest amount left is never reached. 
 * 
 * Dynamic2 uses Integer.MAX_VALUE and there are executions
 * where the array allocation causes an heap overflow 
 *
 * The same holds for Dynamic3.
 */
public class TestChange {

	// static int[] coins = {100,50,20,10,5,2,1};
	static int[] coins = {10,5,2,1};

  public static void main(String[] args) {
     int amount = Integer.parseInt("");
     int c1 = Greedy.change(amount,coins);
     //System.out.println("Greedy Change: "+ c1 + " coins");
     int c2 = Dynamic.change(amount,coins);
     //System.out.println("Dynamic Change: "+ c2 + " coins");
     int c3 = Dynamic2.change(amount,coins);
     //System.out.println("Dynamic2 Change: "+ c3 + " coins"); 
     int c4 = Change.change(amount,coins);    
     //System.out.println("Change: "+ c4 + " coins");
     int c5 = Dynamic3.change(amount,coins);    
     //System.out.println("Dynamic3 Change: "+ c5 + " coins");    
  }
}