#include "common.h"
#include "TraceGenerator.h"

JNIEXPORT jobject JNICALL 
Java_de_uni_1stuttgart_fmi_szs_jmoped_coverage_TraceGenerator_getTraceConfig
(JNIEnv *env, jclass generator, jobject jpds, jobject jfa,
 jlong from, jlong name, jlong to) {

	intPds *ipds = (intPds*)getHandlePointer(env, jpds, "handle");
	assert(ipds != NULL);
	wFA *fa = (wFA*) getHandlePointer(env, jfa, "handle");
	assert(fa != NULL);
  //wFA *fa = ((intResult*)getHandlePointer(env, jresult, "handle"))->sat->fa;
  //jboolean isPostTrace = getBooleanField(env, jresult, "isPostTrace");

	collectGarbage(env);

	bddResult *result = Malloc(sizeof(bddResult));
	result->sat = NULL;
	result->prefix = NULL;
	result->loop = NULL;

	wTrans *transition = wFAFind(fa, from, name, to);
	assert(transition != NULL);

	if (fa->dir == SAT_POST) {
		bddGetPostTrace(ipds->pds, fa, transition, result);
	} else {
		bddGetPreTrace(ipds->pds, fa, transition, result);
	}
	intResult *iresult = intConvertResult(ipds, result);

	jobject config = createIntConfig(env, iresult->prefix, jpds);
  
	iresult->prefix = NULL;
	bddDeleteResult(ipds->pds, result);
	intDeleteResult(iresult);

	return config;
}
