#include "test.h"

#include <coverage.h>
#include <int.h>
#include <ir.h>
#include <absRef.h>

extern int mc_irverbose;

static void testPreStar()
{
  intPds *pds = irReadPds("prestar.rem", 0);
  intProblem problem;
  intResult *result;

  problem.type = PROBLEM_REACHABILITY_PRE;
  problem.isSolved = NULL;
  problem.state = wIdentCreate("q");
  problem.stack = wIdentCreate("de_uni_stuttgart_fmi_szs_jmoped_coverage_PreStarReachabilityTesterTest_PreStarTestClass_main_Ljava_lang_String_V");
  problem.queue = NULL;

  result = intAnalyse(pds, &problem);
  assertEquals(RESULT_YES, result->yesno);

  intDeleteResult(result);

  /* a second run with queue strategy */
  problem.queue = createPreferringNewTransitionsQueueStrategy();

  result = intAnalyse(pds, &problem);
  assertEquals(RESULT_YES, result->yesno);

  freeQueueStrategy(problem.queue);
  intPdsDelete(pds);
}

int main(int argc, char** argv)
{
  TestTuple tests[] = {
    ADD_TEST(testPreStar),
  };
  setUp();
  run_tests(sizeof(tests) / sizeof(TestTuple), tests, argc, argv);
  return 0;
}

/*
 * Local Variables:
 * compile-command: "make -k prestartest"
 * End:
 */
