#include "test.h"

#include <bdd.h>
#include <coverage.h>
#include <int.h>
#include <ir.h>
#include <absRef.h>

extern int mc_irverbose;

static wIdentList* createQuickSortIgnoredList()
{
  wIdentList *excluded = NULL;
  insert(wIdentCreate("de_uni_stuttgart_fmi_szs_jmoped_coverage_" 
 		      "CoverageTesterTest_QuickSort_sort_AIII_V179"),
 	 &excluded);
  return excluded;
}

static wIdentList* createBubbleIgnoredList()
{
  wIdentList *excluded = NULL;
  insert(wIdentCreate("HeapOverflowinitialWrapperFor_BubbleSort_sort_AI_V"), &excluded);
  insert(wIdentCreate("NPEinitialWrapperFor_BubbleSort_sort_AI_V6"), &excluded);
  insert(wIdentCreate("NPEinitialWrapperFor_BubbleSort_sort_AI_V14"), &excluded);
  insert(wIdentCreate("NPEinitialWrapperFor_BubbleSort_sort_AI_V18"), &excluded);
  insert(wIdentCreate("NPEBubbleSort__clinit__V2"), &excluded);
  insert(wIdentCreate("NPEBubbleSort_sort_AI_V12"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsBubbleSort_sort_AI_V12"), &excluded);
  insert(wIdentCreate("NPEBubbleSort_sort_AI_V17"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsBubbleSort_sort_AI_V17"), &excluded);
  insert(wIdentCreate("NPEBubbleSort_sort_AI_V23"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsBubbleSort_sort_AI_V23"), &excluded);
  insert(wIdentCreate("NPEBubbleSort_sort_AI_V32"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsBubbleSort_sort_AI_V32"), &excluded);
  insert(wIdentCreate("NPEBubbleSort_sort_AI_V33"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsBubbleSort_sort_AI_V33"), &excluded);
  insert(wIdentCreate("NPEBubbleSort_sort_AI_V40"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsBubbleSort_sort_AI_V40"), &excluded);
  insert(wIdentCreate("NPEBubbleSort_sort_AI_V46"), &excluded);
  insert(wIdentCreate("NPEBubbleSort_sort_AI_V57"), &excluded);
  insert(wIdentCreate("AssertError"), &excluded);
  insert(wIdentCreate("Exception"), &excluded);
  return excluded;
}

static wIdentList* createNonQuickSortIgnoredList()
{
  wIdentList *excluded = NULL;
  insert(wIdentCreate("HeapOverflowinitialWrapperFor_QuickSort_sort_AI_V"), &excluded);
  insert(wIdentCreate("NPEinitialWrapperFor_QuickSort_sort_AI_V6"), &excluded);
  insert(wIdentCreate("NPEinitialWrapperFor_QuickSort_sort_AI_V14"), &excluded);
  insert(wIdentCreate("NPEinitialWrapperFor_QuickSort_sort_AI_V18"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V26"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V26"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V30"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V30"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V37"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V37"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V46"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V46"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V47"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V47"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V53"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V53"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V63"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V63"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V77"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V77"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V78"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V78"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V84"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V84"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V97"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V97"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V121"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V121"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V142"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V142"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V151"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V151"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V152"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V152"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V158"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V158"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V171"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V171"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V172"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V172"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V178"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsQuickSort_sort_AIII_V178"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V186"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AIII_V196"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AI_V4"), &excluded);
  insert(wIdentCreate("NPEQuickSort_sort_AI_V7"), &excluded);
  insert(wIdentCreate("AssertError"), &excluded);
  insert(wIdentCreate("Exception"), &excluded);
  return excluded;
}

wIdentList* createQuickSortDefaultIgnoredList()
{
  wIdentList *excluded = NULL;
  
  insert(wIdentCreate("HeapOverflowinitialWrapperFor_de_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AI_V"), &excluded);
  insert(wIdentCreate("NPEinitialWrapperFor_de_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AI_V6"), &excluded);
  insert(wIdentCreate("NPEinitialWrapperFor_de_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AI_V14"), &excluded);
  insert(wIdentCreate("NPEinitialWrapperFor_de_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AI_V18"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort__clinit__V2"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V26"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V26"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V30"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V30"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V37"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V37"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V46"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V46"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V47"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V47"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V53"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V53"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V63"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V63"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V77"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V77"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V78"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V78"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V84"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V84"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V97"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V97"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V121"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V121"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V142"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V142"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V151"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V151"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V152"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V152"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V158"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V158"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V192"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V192"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V193"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V193"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V199"), &excluded);
  insert(wIdentCreate("IndexOutOfBoundsde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V199"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V207"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AIII_V217"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AI_V4"), &excluded);
  insert(wIdentCreate("NPEde_uni_stuttgart_fmi_szs_jmoped_coverage_CoverageTesterTest_QuickSort_sort_AI_V7"), &excluded);
  insert(wIdentCreate("Exception"), &excluded);
  return excluded;
}

wIdentList* getIgnoreList(const char *filename)
{
  if (strcmp(filename, "QuickSort3.rem") == 0) {
    return createQuickSortIgnoredList();
  }
  else if (strcmp(filename, "BubbleSortTest.rem") == 0) {
    return createBubbleIgnoredList();
  }
  else if (strcmp(filename, "QuickSortDefault.rem") == 0) {
    return createQuickSortDefaultIgnoredList();
  }
/*    else if (strcmp(filename, "NonQuickSort.rem") == 0) { */
/*      return createNonQuickSortIgnoredList(); */
/*    } */
  return NULL;
}

queueStrategy* getStrategy(const char *name)
{
  if (strcmp(name, "none") == 0) {
    return NULL;
  }
  else if (strcmp(name, "fifo") == 0) {
    return createFIFOQueueStratey();
  }
  else if (strcmp(name, "lifo") == 0) {
    return createLIFOQueueStratey();
  }
  else if (strcmp(name, "new-lifo") == 0) {
    return createPreferringNewTransitionsQueueStrategy();
  }
  else if (strcmp(name, "new-fifo") == 0) {
    return createFIFOPreferringNewTransitionsQueueStrategy();
  }
  return NULL;
}

int main(int argc, char** argv)
{
  if (argc != 3) {
    return 0;
  }
  setUp();

  intPds *pds = irReadPds(argv[1], 0);
  wIdentList *ignored = getIgnoreList(argv[1]);
  queueStrategy *strategy = getStrategy(argv[2]);
  intProblem *problem = createCoverageProblem(pds, NULL, ignored);
  problem->queue = strategy;
  struct tms time;
  clock_t start;
  intResult *result;

  times(&time);
  start = time.tms_utime;
  result = intAnalyse(pds, problem);
  times(&time);

  {
    wIdentList *unreachedStates = getUnreachableStates
      (pds, (coverageContext*)problem->user);
    printf("unreached %d\n", lengthSymList(unreachedStates));
    freeWIdentList(unreachedStates);
  }
    /*
    wIdentList *state;
    printList(unreachedStates);    
    for (state = unreachedStates; state; state = state->next) {
      assert(isNotReachable(pds, state->wId));
    }
    assertEquals(0, lengthSymList(unreachedStates)); 
    assertEquals(0, ((coverageContext*)problem->user)->unvisitedStackElements);
    freeWIdentList(unreachedStates);
  }
*/
  
  printf("%s\t%s\t%d\n", argv[1], argv[2], time.tms_utime - start);
  
  return 0;
}

/*
 * Local Variables:
 * compile-command: "make -k strategyperformancetest"
 * End:
 */
