#include "test.h"

#include <absRef.h>

extern int mc_irverbose;

static void testRemoveIdent()
{
  wIdentList *list = NULL;
  wIdent item1 = wIdentCreate("item1");
  wIdent item2 = wIdentCreate("item2");
  wIdent item3 = wIdentCreate("item3");

  assert(!in(item1, list));
  assert(!in(item2, list));
  assert(!in(item3, list));

  insert(item1, &list);
  insert(item2, &list);
  insert(item3, &list);

  assert(in(item1, list));
  assert(in(item2, list));
  assert(in(item3, list));

  // remove first item
  assert(removeIdent(item1, &list));
  assert(list != NULL);
  assert(!in(item1, list));
  assert(in(item2, list));
  assert(in(item3, list));

  // remove third item
  assert(removeIdent(item3, &list));
  assert(list != NULL);
  assert(!in(item3, list));
  assert(in(item2, list));

  // remove second item
  assert(removeIdent(item2, &list));
  assert(list == NULL);
}

int main(int argc, char** argv)
{
  TestTuple tests[] = {
    ADD_TEST(testRemoveIdent),
  };
  setUp();
  run_tests(sizeof(tests) / sizeof(TestTuple), tests, argc, argv);
  return 0;
}
